Index: /exampleparties/comparebids/src/main/java/geniusweb/exampleparties/comparebids/CompareBids.java
===================================================================
--- /exampleparties/comparebids/src/main/java/geniusweb/exampleparties/comparebids/CompareBids.java	(revision 10)
+++ /exampleparties/comparebids/src/main/java/geniusweb/exampleparties/comparebids/CompareBids.java	(revision 10)
@@ -0,0 +1,103 @@
+package geniusweb.exampleparties.comparebids;
+
+import java.io.IOException;
+import java.util.Arrays;
+import java.util.HashSet;
+import java.util.LinkedList;
+import java.util.List;
+import java.util.logging.Level;
+
+import geniusweb.actions.Action;
+import geniusweb.actions.Comparison;
+import geniusweb.actions.ElicitComparison;
+import geniusweb.actions.PartyId;
+import geniusweb.issuevalue.Bid;
+import geniusweb.party.Capabilities;
+import geniusweb.party.DefaultParty;
+import geniusweb.party.inform.ActionDone;
+import geniusweb.party.inform.Finished;
+import geniusweb.party.inform.Inform;
+import geniusweb.party.inform.Settings;
+import geniusweb.profile.PartialOrdering;
+import geniusweb.profile.Profile;
+import geniusweb.profileconnection.ProfileConnectionFactory;
+import geniusweb.profileconnection.ProfileInterface;
+import tudelft.utilities.logging.Reporter;
+
+/**
+ * A party following the COB protocol and thus answers {@link ElicitComparison}
+ * questions. This party does not use a GUI but uses the given profile to
+ * determine the answer.
+ */
+public class CompareBids extends DefaultParty {
+
+	private PartyId me;
+	protected ProfileInterface profileint;
+
+	public CompareBids() {
+	}
+
+	public CompareBids(Reporter reporter) {
+		super(reporter); // for debugging
+	}
+
+	@Override
+	public void notifyChange(Inform info) {
+		try {
+			if (info instanceof Settings) {
+				Settings settings = (Settings) info;
+				this.profileint = ProfileConnectionFactory
+						.create(settings.getProfile().getURI(), getReporter());
+				this.me = settings.getID();
+			} else if (info instanceof ActionDone) {
+				Action action = ((ActionDone) info).getAction();
+				if (action instanceof ElicitComparison) {
+					reply((ElicitComparison) action);
+				}
+			} else if (info instanceof Finished) {
+			} else {
+				reporter.log(Level.WARNING, "COB party ignores " + info);
+			}
+		} catch (Exception e) {
+			throw new RuntimeException("Failed to handle info", e);
+		}
+	}
+
+	@Override
+	public Capabilities getCapabilities() {
+		return new Capabilities(new HashSet<>(Arrays.asList("COB")));
+	}
+
+	@Override
+	public String getDescription() {
+		return "compares a bid with a given list of other bids.";
+	}
+
+	/**
+	 * Handle the {@link ElicitComparison} and reply with {@link Comparison}.
+	 * This shoul dbe fast (assuming the request is reasonably sized) so we
+	 * handle this in-line instead of in separate thread.
+	 */
+	private void reply(ElicitComparison compareRequest) throws IOException {
+		List<Bid> better = new LinkedList<>();
+		List<Bid> worse = new LinkedList<>();
+		Profile profile1 = profileint.getProfile();
+		if (!(profile1 instanceof PartialOrdering)) {
+			throw new IllegalStateException(
+					"Profile must be a partial ordering");
+		}
+		PartialOrdering profile = (PartialOrdering) profile1;
+
+		Bid bid = compareRequest.getBid();
+		for (Bid otherbid : compareRequest.getOptions()) {
+			boolean betteroreq = profile.isPreferredOrEqual(otherbid, bid);
+			boolean worseoreq = profile.isPreferredOrEqual(bid, otherbid);
+			if (betteroreq && !worseoreq)
+				better.add(otherbid);
+			else if (worseoreq && !betteroreq)
+				worse.add(otherbid);
+		}
+		getConnection().send(new Comparison(me, bid, better, worse));
+	}
+
+}
Index: /exampleparties/comparebids/src/test/java/geniusweb/exampleparties/comparebids/CompareBidsTest.java
===================================================================
--- /exampleparties/comparebids/src/test/java/geniusweb/exampleparties/comparebids/CompareBidsTest.java	(revision 10)
+++ /exampleparties/comparebids/src/test/java/geniusweb/exampleparties/comparebids/CompareBidsTest.java	(revision 10)
@@ -0,0 +1,179 @@
+package geniusweb.exampleparties.comparebids;
+
+import static org.junit.Assert.assertEquals;
+import static org.junit.Assert.assertFalse;
+import static org.junit.Assert.assertNotNull;
+import static org.junit.Assert.assertTrue;
+import static org.mockito.Mockito.mock;
+
+import java.io.IOException;
+import java.math.BigDecimal;
+import java.net.URI;
+import java.net.URISyntaxException;
+import java.nio.charset.StandardCharsets;
+import java.nio.file.Files;
+import java.nio.file.Paths;
+import java.util.LinkedList;
+import java.util.List;
+
+import org.junit.Before;
+import org.junit.Test;
+
+import com.fasterxml.jackson.core.JsonParseException;
+import com.fasterxml.jackson.databind.JsonMappingException;
+import com.fasterxml.jackson.databind.ObjectMapper;
+
+import geniusweb.actions.Action;
+import geniusweb.actions.EndNegotiation;
+import geniusweb.actions.PartyId;
+import geniusweb.bidspace.AllBidsList;
+import geniusweb.connection.ConnectionEnd;
+import geniusweb.issuevalue.Bid;
+import geniusweb.party.Capabilities;
+import geniusweb.party.inform.ActionDone;
+import geniusweb.party.inform.Inform;
+import geniusweb.party.inform.Settings;
+import geniusweb.profile.Profile;
+import geniusweb.profile.utilityspace.LinearAdditive;
+import geniusweb.progress.ProgressRounds;
+import geniusweb.references.Parameters;
+import geniusweb.references.ProfileRef;
+import geniusweb.references.ProtocolRef;
+import geniusweb.references.Reference;
+import tudelft.utilities.listener.DefaultListenable;
+
+public class CompareBidsTest {
+
+	private static final String COB = "COB";
+	private static final PartyId otherparty = new PartyId("other");
+	private static final String PROFILE = "src/test/resources/testprofile.json";
+	private final static ObjectMapper jackson = new ObjectMapper();
+
+	private CompareBids party;
+	private final TestConnection connection = new TestConnection();
+	private final ProtocolRef protocol = mock(ProtocolRef.class);
+	private final ProgressRounds progress = mock(ProgressRounds.class);
+	private Settings settings;
+	private LinearAdditive profile;
+	private final Parameters parameters = new Parameters();
+
+	@Before
+	public void before() throws JsonParseException, JsonMappingException,
+			IOException, URISyntaxException {
+		party = new CompareBids();
+		settings = new Settings(new PartyId("party1"),
+				new ProfileRef(new URI("file:" + PROFILE)), protocol, progress,
+				parameters);
+
+		String serialized = new String(Files.readAllBytes(Paths.get(PROFILE)),
+				StandardCharsets.UTF_8);
+		profile = (LinearAdditive) jackson.readValue(serialized, Profile.class);
+
+	}
+
+	@Test
+	public void smokeTest() {
+	}
+
+	@Test
+	public void getDescriptionTest() {
+		assertNotNull(party.getDescription());
+	}
+
+	@Test
+	public void getCapabilitiesTest() {
+		Capabilities capabilities = party.getCapabilities();
+		assertFalse("party does not define protocols",
+				capabilities.getBehaviours().isEmpty());
+	}
+
+	@Test
+	public void testInformConnection() {
+		party.connect(connection);
+		// agent should not start acting just after an inform
+		assertEquals(0, connection.getActions().size());
+	}
+
+	@Test
+	public void testInformSettings() {
+		party.connect(connection);
+		connection.notifyListeners(settings);
+		assertEquals(0, connection.getActions().size());
+	}
+
+	@Test
+	public void testInformAndConnection() {
+		party.connect(connection);
+		party.notifyChange(settings);
+		assertEquals(0, connection.getActions().size());
+	}
+
+	@Test
+	public void testOtherWalksAway() {
+		party.connect(connection);
+		party.notifyChange(settings);
+
+		party.notifyChange(new ActionDone(new EndNegotiation(otherparty)));
+
+		// party should not act at this point
+		assertEquals(0, connection.getActions().size());
+	}
+
+	@Test
+	public void testGetCapabilities() {
+		assertTrue(party.getCapabilities().getBehaviours().contains(COB));
+	}
+
+	private Bid findGoodBid() {
+		for (Bid bid : new AllBidsList(profile.getDomain())) {
+			if (profile.getUtility(bid)
+					.compareTo(BigDecimal.valueOf(0.7)) > 0) {
+				return bid;
+			}
+		}
+		throw new IllegalStateException(
+				"Test can not be done: there is no good bid with utility>0.7");
+	}
+
+}
+
+/**
+ * A "real" connection object, because the party is going to subscribe etc, and
+ * without a real connection we would have to do a lot of mocks that would make
+ * the test very hard to read.
+ *
+ */
+class TestConnection extends DefaultListenable<Inform>
+		implements ConnectionEnd<Inform, Action> {
+	private List<Action> actions = new LinkedList<>();
+
+	@Override
+	public void send(Action action) throws IOException {
+		actions.add(action);
+	}
+
+	@Override
+	public Reference getReference() {
+		return null;
+	}
+
+	@Override
+	public URI getRemoteURI() {
+		return null;
+	}
+
+	@Override
+	public void close() {
+
+	}
+
+	@Override
+	public Error getError() {
+		return null;
+	}
+
+	public List<Action> getActions() {
+		return actions;
+	}
+
+}
Index: /exampleparties/humangui/src/main/java/geniusweb/exampleparties/humangui/HumanGui.java
===================================================================
--- /exampleparties/humangui/src/main/java/geniusweb/exampleparties/humangui/HumanGui.java	(revision 9)
+++ /exampleparties/humangui/src/main/java/geniusweb/exampleparties/humangui/HumanGui.java	(revision 10)
@@ -2,6 +2,4 @@
 
 import java.awt.BorderLayout;
-import java.net.URI;
-import java.net.URISyntaxException;
 import java.util.Arrays;
 import java.util.HashSet;
@@ -23,5 +21,4 @@
 import geniusweb.profileconnection.ProfileConnectionFactory;
 import geniusweb.profileconnection.ProfileInterface;
-import geniusweb.references.ProtocolRef;
 import tudelft.utilities.logging.Reporter;
 
@@ -85,12 +82,5 @@
 	@Override
 	public Capabilities getCapabilities() {
-		try {
-			return new Capabilities(new HashSet<>(
-					Arrays.asList(new ProtocolRef(new URI("SAOP")))));
-		} catch (URISyntaxException e) {
-			getReporter().log(Level.SEVERE, "Failed to create capabilities URI",
-					e);
-			return null;
-		}
+		return new Capabilities(new HashSet<>(Arrays.asList("SAOP")));
 	}
 
Index: /exampleparties/humangui/src/test/java/geniusweb/exampleparties/humangui/BiddingInfoTest.java
===================================================================
--- /exampleparties/humangui/src/test/java/geniusweb/exampleparties/humangui/BiddingInfoTest.java	(revision 9)
+++ /exampleparties/humangui/src/test/java/geniusweb/exampleparties/humangui/BiddingInfoTest.java	(revision 10)
@@ -32,5 +32,5 @@
 import geniusweb.party.inform.Settings;
 import geniusweb.profile.Profile;
-import geniusweb.profile.utilityspace.LinearAdditiveUtilitySpace;
+import geniusweb.profile.utilityspace.LinearAdditive;
 import geniusweb.profileconnection.ProfileConnectionFactory;
 import geniusweb.profileconnection.ProfileInterface;
@@ -61,5 +61,5 @@
 	private final ProgressRounds progress = mock(ProgressRounds.class);
 	private Settings settings;
-	private LinearAdditiveUtilitySpace profile, profile2;
+	private LinearAdditive profile, profile2;
 	private final Parameters parameters = new Parameters();
 	private Reporter reporter = mock(Reporter.class);
@@ -76,9 +76,8 @@
 		String serialized = new String(Files.readAllBytes(Paths.get(PROFILE)),
 				StandardCharsets.UTF_8);
-		profile = (LinearAdditiveUtilitySpace) jackson.readValue(serialized,
-				Profile.class);
+		profile = (LinearAdditive) jackson.readValue(serialized, Profile.class);
 		String serialized2 = new String(Files.readAllBytes(Paths.get(PROFILE2)),
 				StandardCharsets.UTF_8);
-		profile2 = (LinearAdditiveUtilitySpace) jackson.readValue(serialized2,
+		profile2 = (LinearAdditive) jackson.readValue(serialized2,
 				Profile.class);
 
Index: /exampleparties/humangui/src/test/java/geniusweb/exampleparties/humangui/HumanGuiTest.java
===================================================================
--- /exampleparties/humangui/src/test/java/geniusweb/exampleparties/humangui/HumanGuiTest.java	(revision 9)
+++ /exampleparties/humangui/src/test/java/geniusweb/exampleparties/humangui/HumanGuiTest.java	(revision 10)
@@ -34,5 +34,5 @@
 import geniusweb.party.inform.YourTurn;
 import geniusweb.profile.Profile;
-import geniusweb.profile.utilityspace.LinearAdditiveUtilitySpace;
+import geniusweb.profile.utilityspace.LinearAdditive;
 import geniusweb.progress.ProgressRounds;
 import geniusweb.references.Parameters;
@@ -57,5 +57,5 @@
 	private final ProgressRounds progress = mock(ProgressRounds.class);
 	private Settings settings;
-	private LinearAdditiveUtilitySpace profile;
+	private LinearAdditive profile;
 	private final Parameters parameters = new Parameters();
 
@@ -70,6 +70,5 @@
 		String serialized = new String(Files.readAllBytes(Paths.get(PROFILE)),
 				StandardCharsets.UTF_8);
-		profile = (LinearAdditiveUtilitySpace) jackson.readValue(serialized,
-				Profile.class);
+		profile = (LinearAdditive) jackson.readValue(serialized, Profile.class);
 
 	}
@@ -93,10 +92,10 @@
 		Capabilities capabilities = party.getCapabilities();
 		assertFalse("party does not define protocols",
-				capabilities.getProtocols().isEmpty());
+				capabilities.getBehaviours().isEmpty());
 	}
 
 	@Test
 	public void testGetCapabilities() {
-		assertTrue(party.getCapabilities().getProtocols().contains(SAOP));
+		assertTrue(party.getCapabilities().getBehaviours().contains(SAOP));
 	}
 
Index: /exampleparties/randomparty/src/main/java/geniusweb/exampleparties/randomparty/RandomParty.java
===================================================================
--- /exampleparties/randomparty/src/main/java/geniusweb/exampleparties/randomparty/RandomParty.java	(revision 9)
+++ /exampleparties/randomparty/src/main/java/geniusweb/exampleparties/randomparty/RandomParty.java	(revision 10)
@@ -3,6 +3,4 @@
 import java.io.IOException;
 import java.math.BigInteger;
-import java.net.URI;
-import java.net.URISyntaxException;
 import java.util.Arrays;
 import java.util.HashSet;
@@ -30,5 +28,4 @@
 import geniusweb.progress.Progress;
 import geniusweb.progress.ProgressRounds;
-import geniusweb.references.ProtocolRef;
 import tudelft.utilities.logging.Reporter;
 
@@ -81,12 +78,5 @@
 	@Override
 	public Capabilities getCapabilities() {
-		try {
-			return new Capabilities(new HashSet<>(
-					Arrays.asList(new ProtocolRef(new URI("SAOP")))));
-		} catch (URISyntaxException e) {
-			getReporter().log(Level.SEVERE, "Failed to create capabilities URI",
-					e);
-			return null;
-		}
+		return new Capabilities(new HashSet<>(Arrays.asList("SAOP")));
 	}
 
@@ -115,5 +105,5 @@
 	}
 
-	private boolean isGood(Bid bid) {
+	private boolean isGood(Bid bid) throws IOException {
 		if (bid == null)
 			return false;
Index: /exampleparties/randomparty/src/test/java/geniusweb/exampleparties/randomparty/RandomPartyTest.java
===================================================================
--- /exampleparties/randomparty/src/test/java/geniusweb/exampleparties/randomparty/RandomPartyTest.java	(revision 9)
+++ /exampleparties/randomparty/src/test/java/geniusweb/exampleparties/randomparty/RandomPartyTest.java	(revision 10)
@@ -42,5 +42,5 @@
 import geniusweb.party.inform.YourTurn;
 import geniusweb.profile.Profile;
-import geniusweb.profile.utilityspace.LinearAdditiveUtilitySpace;
+import geniusweb.profile.utilityspace.LinearAdditive;
 import geniusweb.progress.ProgressRounds;
 import geniusweb.references.Parameters;
@@ -53,5 +53,5 @@
 public class RandomPartyTest {
 
-	private static final ProtocolRef SAOP = new ProtocolRef("SAOP");
+	private static final String SAOP = "SAOP";
 	private static final PartyId otherparty = new PartyId("other");
 	private static final String PROFILE = "src/test/resources/testprofile.json";
@@ -63,5 +63,5 @@
 	private final ProgressRounds progress = mock(ProgressRounds.class);
 	private Settings settings;
-	private LinearAdditiveUtilitySpace profile;
+	private LinearAdditive profile;
 	private final Parameters parameters = new Parameters();
 
@@ -76,6 +76,5 @@
 		String serialized = new String(Files.readAllBytes(Paths.get(PROFILE)),
 				StandardCharsets.UTF_8);
-		profile = (LinearAdditiveUtilitySpace) jackson.readValue(serialized,
-				Profile.class);
+		profile = (LinearAdditive) jackson.readValue(serialized, Profile.class);
 
 	}
@@ -94,5 +93,5 @@
 		Capabilities capabilities = party.getCapabilities();
 		assertFalse("party does not define protocols",
-				capabilities.getProtocols().isEmpty());
+				capabilities.getBehaviours().isEmpty());
 	}
 
@@ -176,5 +175,5 @@
 	@Test
 	public void testGetCapabilities() {
-		assertTrue(party.getCapabilities().getProtocols().contains(SAOP));
+		assertTrue(party.getCapabilities().getBehaviours().contains(SAOP));
 	}
 
Index: /exampleparties/randompartypy/src/main/resources/RandomParty.py
===================================================================
--- /exampleparties/randompartypy/src/main/resources/RandomParty.py	(revision 9)
+++ /exampleparties/randompartypy/src/main/resources/RandomParty.py	(revision 10)
@@ -65,9 +65,5 @@
 	# Override
 	def getCapabilities(self): # -> Capabilities
-		try:
-			return Capabilities(HashSet([ ProtocolRef(URI("SAOP"))]))
-		except:
-			getReporter().log(Level.SEVERE, "Failed to create capabilities URI",e);
-		return None
+			return Capabilities(HashSet([ "SAOP"]))
 
 	# Override
Index: /exampleparties/randompartypy/src/test/java/geniusweb/exampleparties/randompartypy/RandomPartyTest.java
===================================================================
--- /exampleparties/randompartypy/src/test/java/geniusweb/exampleparties/randompartypy/RandomPartyTest.java	(revision 9)
+++ /exampleparties/randompartypy/src/test/java/geniusweb/exampleparties/randompartypy/RandomPartyTest.java	(revision 10)
@@ -39,5 +39,5 @@
 import geniusweb.party.inform.YourTurn;
 import geniusweb.profile.Profile;
-import geniusweb.profile.utilityspace.LinearAdditiveUtilitySpace;
+import geniusweb.profile.utilityspace.LinearAdditive;
 import geniusweb.progress.ProgressRounds;
 import geniusweb.pythonadapter.PythonPartyAdapter;
@@ -51,5 +51,5 @@
 
 	private static final String PROFILE = "src/test/resources/testprofile.json";
-	private static final ProtocolRef SAOP = new ProtocolRef("SAOP");
+	private static final String SAOP = "SAOP";
 	private static final PartyId otherparty = new PartyId("other");
 	private final static ObjectMapper jackson = new ObjectMapper();
@@ -62,5 +62,5 @@
 	private final Parameters parameters = new Parameters();
 
-	private LinearAdditiveUtilitySpace profile; // the real profile
+	private LinearAdditive profile; // the real profile
 
 	@Before
@@ -80,6 +80,5 @@
 		String serialized = new String(Files.readAllBytes(Paths.get(PROFILE)),
 				StandardCharsets.UTF_8);
-		profile = (LinearAdditiveUtilitySpace) jackson.readValue(serialized,
-				Profile.class);
+		profile = (LinearAdditive) jackson.readValue(serialized, Profile.class);
 
 	}
@@ -98,5 +97,5 @@
 		Capabilities capabilities = party.getCapabilities();
 		assertFalse("party does not define protocols",
-				capabilities.getProtocols().isEmpty());
+				capabilities.getBehaviours().isEmpty());
 	}
 
@@ -167,5 +166,5 @@
 	@Test
 	public void testGetCapabilities() {
-		assertTrue(party.getCapabilities().getProtocols().contains(SAOP));
+		assertTrue(party.getCapabilities().getBehaviours().contains(SAOP));
 	}
 
Index: /exampleparties/simpleshaop/src/main/java/geniusweb/exampleparties/simpleshaop/ShaopParty.java
===================================================================
--- /exampleparties/simpleshaop/src/main/java/geniusweb/exampleparties/simpleshaop/ShaopParty.java	(revision 10)
+++ /exampleparties/simpleshaop/src/main/java/geniusweb/exampleparties/simpleshaop/ShaopParty.java	(revision 10)
@@ -0,0 +1,147 @@
+package geniusweb.exampleparties.simpleshaop;
+
+import java.io.IOException;
+import java.math.BigDecimal;
+import java.math.BigInteger;
+import java.util.Arrays;
+import java.util.HashSet;
+import java.util.Random;
+import java.util.logging.Level;
+
+import geniusweb.actions.Accept;
+import geniusweb.actions.Action;
+import geniusweb.actions.Comparison;
+import geniusweb.actions.ElicitComparison;
+import geniusweb.actions.Offer;
+import geniusweb.actions.PartyId;
+import geniusweb.bidspace.AllPartialBidsList;
+import geniusweb.issuevalue.Bid;
+import geniusweb.party.Capabilities;
+import geniusweb.party.DefaultParty;
+import geniusweb.party.inform.ActionDone;
+import geniusweb.party.inform.Finished;
+import geniusweb.party.inform.Inform;
+import geniusweb.party.inform.Settings;
+import geniusweb.party.inform.YourTurn;
+import geniusweb.profile.PartialOrdering;
+import geniusweb.profileconnection.ProfileConnectionFactory;
+import geniusweb.profileconnection.ProfileInterface;
+import geniusweb.progress.Progress;
+import geniusweb.progress.ProgressRounds;
+import tudelft.utilities.logging.Reporter;
+
+/**
+ * A simple implementation of a SHAOP party that can handle only bilateral
+ * negotiations (1 other party). It will ignore all other parties except the one
+ * that has the turn right before us. It estimates the utilities of bids by
+ * assigning a linear increasing utility from the orderings that have been
+ * created.
+ * <p>
+ * <b>Requirement<b> the initial {@link PartialOrdering} must contain at least
+ * the bids with lowest utility and highest utility, and the proper comparison
+ * info for these two bids.
+ */
+public class ShaopParty extends DefaultParty {
+
+	private static final BigDecimal N09 = new BigDecimal("0.9");
+	private Bid lastReceivedBid = null; // we ignore all others
+	private PartyId me;
+	private final Random random = new Random();
+	protected ProfileInterface profileint;
+	private Progress progress;
+	private SimpleLinearOrdering estimatedProfile = null;
+
+	public ShaopParty() {
+	}
+
+	public ShaopParty(Reporter reporter) {
+		super(reporter); // for debugging
+	}
+
+	@Override
+	public void notifyChange(Inform info) {
+		try {
+			if (info instanceof Settings) {
+				Settings settings = (Settings) info;
+				this.profileint = ProfileConnectionFactory
+						.create(settings.getProfile().getURI(), getReporter());
+				this.me = settings.getID();
+				this.progress = settings.getProgress();
+			} else if (info instanceof ActionDone) {
+				Action otheract = ((ActionDone) info).getAction();
+				if (otheract instanceof Offer) {
+					lastReceivedBid = ((Offer) otheract).getBid();
+				} else if (otheract instanceof Comparison) {
+					estimatedProfile = estimatedProfile.with(
+							((Comparison) otheract).getBid(),
+							((Comparison) otheract).getWorse());
+					myTurn();
+				}
+			} else if (info instanceof YourTurn) {
+				myTurn();
+			} else if (info instanceof Finished) {
+				getReporter().log(Level.INFO, "Final ourcome:" + info);
+			}
+		} catch (Exception e) {
+			throw new RuntimeException("Failed to handle info", e);
+		}
+	}
+
+	@Override
+	public Capabilities getCapabilities() {
+		return new Capabilities(new HashSet<>(Arrays.asList("SHAOP")));
+	}
+
+	@Override
+	public String getDescription() {
+		return "Communicates with COB party to figure out which bids are good. Accepts bids with utility > 0.9. Offers random bids.";
+	}
+
+	/**
+	 * Called when it's (still) our turn and we should take some action. Also
+	 * Updates the progress if necessary.
+	 */
+	private void myTurn() throws IOException {
+		Action action = null;
+		if (estimatedProfile == null) {
+			estimatedProfile = new SimpleLinearOrdering(
+					profileint.getProfile());
+		}
+
+		if (lastReceivedBid != null) {
+			// then we do the action now, no need to ask user
+			if (estimatedProfile.contains(lastReceivedBid)) {
+				if (isGood(lastReceivedBid)) {
+					action = new Accept(me, lastReceivedBid);
+				}
+			} else {
+				// we did not yet assess the received bid
+				action = new ElicitComparison(me, lastReceivedBid,
+						estimatedProfile.getBids());
+			}
+			if (progress instanceof ProgressRounds) {
+				progress = ((ProgressRounds) progress).advance();
+			}
+		}
+		// Otherwise just offer a Random bid
+		// FIXME this is weird, can't we do better than random?
+		if (action == null)
+			action = randomBid();
+		getConnection().send(action);
+	}
+
+	private Offer randomBid() throws IOException {
+		AllPartialBidsList bidspace = new AllPartialBidsList(
+				profileint.getProfile().getDomain());
+		long i = random.nextInt(bidspace.size().intValue());
+		Bid bid = bidspace.get(BigInteger.valueOf(i));
+		return new Offer(me, bid);
+	}
+
+	private boolean isGood(Bid bid) {
+		if (bid == null)
+			return false;
+		return estimatedProfile.getUtility(bid).compareTo(N09) >= 0;
+	}
+
+}
Index: /exampleparties/simpleshaop/src/main/java/geniusweb/exampleparties/simpleshaop/SimpleLinearOrdering.java
===================================================================
--- /exampleparties/simpleshaop/src/main/java/geniusweb/exampleparties/simpleshaop/SimpleLinearOrdering.java	(revision 10)
+++ /exampleparties/simpleshaop/src/main/java/geniusweb/exampleparties/simpleshaop/SimpleLinearOrdering.java	(revision 10)
@@ -0,0 +1,125 @@
+package geniusweb.exampleparties.simpleshaop;
+
+import java.math.BigDecimal;
+import java.math.RoundingMode;
+import java.util.Collections;
+import java.util.Comparator;
+import java.util.LinkedList;
+import java.util.List;
+
+import geniusweb.issuevalue.Bid;
+import geniusweb.issuevalue.Domain;
+import geniusweb.profile.DefaultPartialOrdering;
+import geniusweb.profile.Profile;
+import geniusweb.profile.utilityspace.UtilitySpace;
+
+/**
+ * A simple list of bids, but all bids are fully ordered (better or worse than
+ * other bids in the list).
+ */
+public class SimpleLinearOrdering implements UtilitySpace {
+
+	private final Domain domain;
+	private final List<Bid> bids; // worst bid first, best bid last.
+
+	SimpleLinearOrdering(Profile profile) {
+		this(profile.getDomain(), getSortedBids(profile));
+	}
+
+	/**
+	 * 
+	 * @param domain
+	 * @param bids   a list of bids, ordered from lowest to highest util. The
+	 *               first bid will have utility 0, the last utility 1. If only
+	 *               0 or 1 bid in the list, or if the bid is not known, it will
+	 *               have utility 0.
+	 */
+	SimpleLinearOrdering(Domain domain, List<Bid> bids) {
+		this.domain = domain;
+		this.bids = bids;
+	}
+
+	@Override
+	public String getName() {
+		throw new UnsupportedOperationException();
+	}
+
+	@Override
+	public Domain getDomain() {
+		return domain;
+	}
+
+	@Override
+	public Bid getReservationBid() {
+		throw new UnsupportedOperationException();
+	}
+
+	@Override
+	public BigDecimal getUtility(Bid bid) {
+		if (bids.size() < 2 || !bids.contains(bid)) {
+			return BigDecimal.ZERO;
+		}
+		// using 8 decimals, we have to pick something here
+		return new BigDecimal(bids.indexOf(bid)).divide(
+				new BigDecimal((bids.size() - 1)), 8, RoundingMode.HALF_UP);
+	}
+
+	/**
+	 * 
+	 * @param bid
+	 * @return true iff bid is contained in this ordering
+	 */
+	public boolean contains(Bid bid) {
+		return bids.contains(bid);
+	}
+
+	/**
+	 * 
+	 * @return list of all bids in the current ordering.
+	 */
+	public List<Bid> getBids() {
+		return Collections.unmodifiableList(bids);
+	}
+
+	/**
+	 * 
+	 * @param profile
+	 * @return a list of bids in the profile sorted from low to high utility.
+	 */
+	private static List<Bid> getSortedBids(Profile profile) {
+		if (!(profile instanceof DefaultPartialOrdering)) {
+			throw new UnsupportedOperationException(
+					"Only DefaultPartialOrdering supported");
+		}
+		DefaultPartialOrdering prof = (DefaultPartialOrdering) profile;
+		List<Bid> bidslist = prof.getBids();
+		Collections.sort(bidslist, new Comparator<Bid>() {
+
+			@Override
+			public int compare(Bid b1, Bid b2) {
+				// notice, -1 if better because WORST bid first
+				return prof.isPreferredOrEqual(b1, b2) ? -1 : 1;
+			}
+
+		});
+
+		return bidslist;
+	}
+
+	/**
+	 * @param bid       a new bid to be inserted
+	 * @param worseBids all bids that are worse than this bid.
+	 * @return a SimpleLinearOrdering, updated with the given comparison. Thee
+	 *         bid will be inserted after the first bid that is not worse than
+	 *         bid.
+	 */
+	public SimpleLinearOrdering with(Bid bid, List<Bid> worseBids) {
+		int n = 0;
+		while (n < bids.size() && worseBids.contains(bids.get(n)))
+			n++;
+		LinkedList<Bid> newbids = new LinkedList<Bid>(bids);
+		newbids.add(n, bid);
+		return new SimpleLinearOrdering(domain, newbids);
+	}
+
+}
